/*
 * XmlConf.h
 *
 *  Created on: 10/02/2009
 *      Author: janno
 */

#ifndef XMLCONF_H_
#define XMLCONF_H_

#include "Conf.h"

namespace digidoc
{

class XmlConfPrivate;
class EXP_DIGIDOC XmlConf: public Conf
{
public:
    static void initialize();
    XmlConf() throw(IOException);
    XmlConf(const std::string& path) throw(IOException);
    virtual ~XmlConf();

    virtual int getLogLevel() const;
    virtual std::string getLogFile() const;
    virtual std::string getDigestUri() const;
    virtual std::string getSignatureUri() const;
    virtual std::string getManifestXsdPath() const;
    virtual std::string getXadesXsdPath() const;
    virtual std::string getDsigXsdPath() const;
    virtual std::string getPKCS11DriverPath() const;
    virtual OCSPConf getOCSP(const std::string &issuer) const;
    virtual std::string getCertStorePath() const;
    virtual std::string getProxyHost() const;
    virtual std::string getProxyPort() const;
    virtual std::string getProxyUser() const;
    virtual std::string getProxyPass() const;
    virtual std::string getPKCS12Cert() const;
    virtual std::string getPKCS12Pass() const;
    virtual bool getPKCS12Disable() const;

	static std::string getUserConfDir();
    static std::string getDefaultConfDir();

    virtual void setProxyHost( const std::string &host ) throw(IOException);
    virtual void setProxyPort( const std::string &port ) throw(IOException);
    virtual void setProxyUser( const std::string &user ) throw(IOException);
    virtual void setProxyPass( const std::string &pass ) throw(IOException);
    virtual void setPKCS12Cert( const std::string &cert ) throw(IOException);
    virtual void setPKCS12Pass( const std::string &pass ) throw(IOException);
    virtual void setPKCS12Disable( bool disable ) throw(IOException);

    virtual void setOCSP(const std::string &issuer, const std::string &url, const std::string &cert) throw(IOException);

private:
	XmlConfPrivate *d;
};

}

#endif /* XMLCONF_H_ */
