#if !defined(__X509CERTSTORE_H_INCLUDED__)
#define __X509CERTSTORE_H_INCLUDED__

#include "X509Cert.h"

namespace digidoc
{
    /**
     * X.509 certificate store interface.
     */
    class X509CertStorePrivate;
    class EXP_DIGIDOC X509CertStore
    {
      public:
          virtual ~X509CertStore();
          static void init(X509CertStore *impl = 0);
          static void destroy();
          static X509CertStore* getInstance() throw(IOException);

          virtual X509_STORE* getCertStore() const throw(IOException);
          virtual STACK_OF(X509)* getCerts() const  throw(IOException);
          virtual X509* getCert(long certSerial) const throw(IOException);
          virtual X509* getCert(const X509_NAME &subject) const throw(IOException);
          virtual STACK_OF(X509)* findCerts(const std::string &obj, const std::string &name) const throw(IOException);

      private:
          X509CertStore();

          static X509CertStore* INSTANCE;
          X509CertStorePrivate *d;

          friend class DirectoryX509CertStore;
          friend class MSX509CertStore;
          friend class MACX509CertStore;
    };
}

#endif // !defined(__X509CERTSTORE_H_INCLUDED__)
