#if !defined(__ESTEIDSIGNER_H_INCLUDED__)
#define __ESTEIDSIGNER_H_INCLUDED__

#include "PKCS11Signer.h"

namespace digidoc
{
    /**
     * Implements EstEID ID-Card signer. Selects the correct certificate for signing by
     * implementing abstract method <code>selectSigningCertificate</code>, which select
     * the correct certificate by certificate key usage.
     *
     * @author Janari Põld
     */
    class EXP_DIGIDOC EstEIDSigner : public PKCS11Signer
    {

      public:
          EstEIDSigner(const std::string &driver) throw(SignException);
          virtual ~EstEIDSigner();

          int type() const;

      protected:
          virtual PKCS11Cert selectSigningCertificate(const std::vector<PKCS11Cert> &certificates) const throw(SignException);
    };

}

#endif // !defined(__ESTEIDSIGNER_H_INCLUDED__)
